<?php
if ( ! defined('BASEPATH')) exit('No direct script access allowed');
class Billing_building_fund extends REF_Controller {
    public function __construct() {
        parent::__construct();
        $this->load->library('upload');
        $this->load->model('billing/building_fund_model', '', TRUE);
        $this->load->model('login_details_model', '', TRUE);
        $this->uri_key_index = 0;
    }
    
    public function index($id = 3) {
        $data = array();
        $data['results'] = $this->building_fund_model->list_all();
        if (!empty($this->session->flashdata('success'))) 
            $data['success'] = $this->session->flashdata('success');
        else 
            $data['error'] = $this->session->flashdata('error');
        
        $actions = $this->actions();
        $data['add_btn']    = 'Create New Building Fund Details';
        $data['view_link']  = $actions['view'] . '/';
        $data['add_link']   = $actions['add'] . '/' . $id ;
        $data['edit_link']  = $actions['edit'] . '/';
        $data['delete_link']= $actions['delete'] . '/';
        $data['print']      = base_url() . 'billing_building_fund/print_list/';
        $data['title'] = 'Building Fund';
        $data['menu_id'] = $id;
        
        $service_menu = get_billing_controller($actions['controller']);
        $data['title'] = $service_menu->service_name;
        $data['service_menu_id'] = array('service_menu_id' => $service_menu->id, 'menu_type' => '4');
        $this->render($data, 'billing/building_fund/list');
    }
    
    public function add($type_id= '') {
        $data = array();
        $actions = $this->actions();
        $data['fn_types'] = $this->building_fund_model->get( TBL_SERVICE, array( 'menu_name' => $type_id ) );
        $data['service_type_id'] = $type_id;
        $data['payments'] = $this->building_fund_model->payment_mode_lists();
        
        $data['form_action'] = $actions['insert'];
        $data['title'] = 'Building Fund';
        $this->render($data, 'billing/building_fund/add');
    }
    
    private function get_building_url_key($name, $id = '') {
        $url_key = get_url_key($name);
        if ($this->building_fund_model->building_url_key_exists($url_key, $id)) {
            $this->uri_key_index ++;
            return $this->get_building_url_key($name . '_' . $this->uri_key_index, $id);
        }
        
        return $url_key;
    }
    
    public function insert() {
        $services = $this->building_fund_model->service_type_exists($this->input->post('fn_type'));
        $gst_details = $this->login_details_model->get_amount_by_service_id($this->input->post('fn_type'));
        
        if($gst_details->gst == 1) {
            $gst = get_general_setting()->gst; 
            $gst_amount = ($gst / 100) * ($this->input->post('cs_amount'));
        } else {
            $gst = '0.00';
            $gst_amount = '0.00';
        }
        $insert = array(
            'type_id' => $this->input->post('type_id'),
            'service_id' => $this->input->post('fn_type'),
            'name' => $this->input->post('name'),
            'tamil_name' => $this->input->post('tamil_name'),
            'contact_no' => $this->input->post('contact_no'),
            'email' => $this->input->post('ct_email'),
            'address' => $this->input->post('ct_address'),
            'desc' => $this->input->post('cs_desc'),
            'gst' => $gst,
            'gst_value' => $gst_amount,
            'amount' => $this->input->post('cs_amount'),
            'url_key' => $this->get_building_url_key($this->input->post('name')),
            'created_by' => $this->user_data['user_id'],
            'created_on' => date('Y-m-d H:i:s')
        );
        
        $insert_id = $this->building_fund_model->insert($insert);
        
        if ($insert_id > 0) {
            $this->session->set_flashdata('success', 'Billing for Building Fund is added successfully');
            if($services->num_rows() > 0) {
                $last_receipt_no = $services->row()->receipt_no;
                $last_no = (int)$last_receipt_no;
                $receipt_no = (($last_no + 1)  > 999) ? ($last_no + 1)  : sprintf('0%03d', ($last_no + 1) );
            } else
                $receipt_no = '0001';
            
            $update = array(
                'receipt_no' => $receipt_no
            );
            $this->building_fund_model->update($update, $insert_id);
           
            $pay_type = $this->input->post('pay_type');
            
            foreach( $pay_type as $key => $value ) {
                if($value != '') {
                    $this->db->select('slug');
                    $q = $this->db->get_where( TBL_PAY_TYPE, array('id' => $key) );
                    $prow = $q->row_array();
                   
                    $pay_details = array();
                    if( $prow['slug'] == 'cheque' && !empty($value) ) :
                       // Cheque
                        $e = explode('-', $this->input->post('chq_date'));
                        $pay_details = array(
                           'name'   => $this->input->post('chq_bnk_name'),
                           'no'   => $this->input->post('chq_no'),
                           'date'   => $e[2].'-'.$e[1].'-'.$e[0],
                        );
                    endif;
                   
                    $pay_details = json_encode( $pay_details );
                    $insert = array(
                        'pay_ref_type'  => 3,
                        'pay_ref_id'    => $insert_id,
                        'pay_type_id'   => $key,
                        'pay_amount'    => $value,
                        'pay_details'   => $pay_details,
                        'status'        => 1,
                        'created_by'    => $this->user_data['user_id'],
                        'created_on'    => date('Y-m-d H:i:s')
                    );
                    $this->building_fund_model->insert_payment($insert);
                }
            }
            
            /*** To Print Receipt - Start ***/
            $service_menu = $this->login_details_model->get_service_menu_by_id($this->input->post('type_id'));
            $prefix = get_general_setting()->prefix;
            
            $args = array(
                'type'      => '1', // Default = 1 // Normal (Double print), '2' => Archanai,   '3' = Hall Booking | Wedding Hall
                'rec_no'    => (($prefix == 1) ? $gst_details->prefix : '') . $receipt_no,
                'title'     => $service_menu->service_name . ' - ' . $gst_details->name,
                'amount'    => array($this->input->post('cs_amount')),
                'gst'       => $gst_details->gst,
                'printType' => FALSE,
                
                'data'      => array(
                    // Type = 1 && 3 
                    'name'      => array($this->input->post('name') .','. $this->input->post('tamil_name')),
                    'contact_no'=> $this->input->post('contact_no'),
                    'email'     => $this->input->post('ct_email'),
                    'address'   => $this->input->post('ct_address'),
                    'desc'      => $this->input->post('cs_desc'),
                ),
                
            );
            
            print_rec($args);            
            /*** End ***/
        }
        else
            $this->session->set_flashdata('error', 'Billing for Building Fund is not added!');
        
        redirect('billing_building_fund', 'refresh');
    }
    
    public function edit($id = '') {
        if (empty($id)) {
            show_400_error();
        }
        
        $data = array();
        $actions = $this->actions();
        $data['form_action'] = $actions['update'] . '/' . $id;
        
        $data['building'] = $this->building_fund_model->get_by_id($id);
        $data['paid_amount'] = $this->building_fund_model->total_paid_amount($data['building']->type_id,$data['building']->id);
        $data['fn_types'] = $this->building_fund_model->get( TBL_SERVICE, array( 'menu_name' => $data['building']->type_id ) );
        $data['payments'] = $this->building_fund_model->payment_mode_lists();
        
        $data['title'] = 'Building Fund';
        $this->render($data, 'billing/building_fund/edit');
    }
    
    public  function update($id){
        if (empty($id)) {
            show_400_error();
        }
        
        $building = $this->building_fund_model->get_by_id($id);
        $gst_details = $this->login_details_model->get_amount_by_service_id($this->input->post('fn_type'));
        
        if($gst_details->gst == 1) {
            $gst = get_general_setting()->gst;
            $gst_amount = ($gst / 100) * ($this->input->post('cs_amount'));
        } else {
            $gst = '0.00';
            $gst_amount = '0.00';
        }
        
        $update = array(
            'type_id' => $this->input->post('type_id'),
            'service_id' => $this->input->post('fn_type'),
            'name' => $this->input->post('name'),
            'tamil_name' => $this->input->post('tamil_name'),
            'contact_no' => $this->input->post('contact_no'),
            'email' => $this->input->post('ct_email'),
            'address' => $this->input->post('ct_address'),
            'desc' => $this->input->post('cs_desc'),
            'gst' => $gst,
            'gst_value' => $gst_amount,
            'amount' => $this->input->post('cs_amount'),
            'url_key' => $this->get_building_url_key($this->input->post('name')),
            'updated_by' => $this->user_data['user_id'],
            'updated_on' => date('Y-m-d H:i:s')
        );
        
        $affected_rows = $this->building_fund_model->update($update,$id);
        
        if($affected_rows > 0) {
           $this->session->set_flashdata('success', 'Billing for Building Fund is updated successfully');
            $paid_hidden_id = $this->input->post('paid_hidden_id');
            if(!empty($paid_hidden_id)) :
                $paidtype = $this->building_fund_model->delete_payment_by_paid_id($paid_hidden_id);
            endif;
            
            $pay_type = $this->input->post('pay_type');
            foreach( $pay_type as $key => $value ) {
                if($value != '') {
                    $this->db->select('slug');
                    $q = $this->db->get_where( TBL_PAY_TYPE, array('id' => $key) );
                    $prow = $q->row_array();
                   
                    $pay_details = array();
                    if( $prow['slug'] == 'cheque' && !empty($value) ) :
                       // Cheque
                        $e = explode('-', $this->input->post('chq_date'));
                        $pay_details = array(
                           'name'   => $this->input->post('chq_bnk_name'),
                           'no'   => $this->input->post('chq_no'),
                           'date'   => $e[2].'-'.$e[1].'-'.$e[0],
                        );
                    endif;
                   
                    $pay_details = json_encode( $pay_details );
                    $insert = array(
                        'pay_ref_type'  => 3,
                        'pay_ref_id'    => $id,
                        'pay_type_id'   => $key,
                        'pay_amount'    => $value,
                        'pay_details'   => $pay_details,
                        'status'        => 1,
                        'created_by'    => $this->user_data['user_id'],
                        'created_on'    => $building->created_on
                    );
                    $this->building_fund_model->insert_payment($insert);
                }
            }
            
        } else 
            $this->session->set_flashdata('error', 'Billing for Building Fund is not updated!');
        
        redirect( 'billing_building_fund', 'refresh');
    }
    
    public function view($id = '') {
        if (empty($id)) {
            show_400_error();
        }
        
        $data = array();
        $data['building'] = $this->building_fund_model->get_by_id($id);
        $data['paid_amount'] = $this->building_fund_model->total_paid_amount($data['building']->type_id,$data['building']->id);
        $data['payments'] = $this->building_fund_model->get_paid_type_by_id($data['building']->type_id,$id);
        $data['title'] = 'Building Fund';
        $this->render($data, 'billing/building_fund/view');
    }
    
    public function delete($id = '',$menu_id = '') {
        if (empty($id)) {
            show_400_error();
        }
        
        $update = array ( 
            'amount' => 0,
            'del_reason' => $this->input->post('hidden_del_reason'),
            'status' => 2,
            'updated_by' => $this->user_data['user_id'],
            'updated_on' => date('Y-m-d H:i:s')
        );

        if ($this->building_fund_model->update($update,$id) > 0) {
            $this->session->set_flashdata('success', 'Billing for Building Fund is deleted successfully');
            $building = $this->building_fund_model->get_by_id($id);
            
            $update = array ( 
                'pay_amount' => 0,
                'updated_by' => $this->user_data['user_id'],
                'updated_on' => date('Y-m-d H:i:s')
            );
            
            $this->building_fund_model->update_paid_type($update,$building->type_id,$id);
        }
        
        else 
            $this->session->set_flashdata('error', 'Billing for Building Fund is not deleted!');
        
        redirect( 'billing_building_fund/index/' . $menu_id, 'refresh');
    }
    
    public function get_amount_by_service_id() {
        $data =  $this->building_fund_model->get_amount_by_service_id($_POST['service_type']);
        echo json_encode($data);
        exit(0);
    }
    
    public function get_data_by_service_type(){
        $data['get_data'] =  $this->building_fund_model->get_data_by_service_type($_POST['service_type'],$_POST['search_by']);
        echo json_encode($data);
        exit(0);
    }
    
    public function ajax() {
        $data =  $this->building_fund_model->ajax();
        echo json_encode($data);
        exit(0);  
    }
    
    public function print_list($id,$menu_id) {
        $building = $this->building_fund_model->get_by_id($id);
        
        /*** To Print Receipt - Start ***/
        $service_menu = $this->login_details_model->get_service_menu_by_id($building->type_id);
        $gst_details = $this->login_details_model->get_amount_by_service_id($building->service_id);
        $prefix = get_general_setting()->prefix;
        
        $args = array(
            'type'      => '1', // Default = 1 // Normal (Double print), '2' => Archanai,   '3' = Hall Booking | Wedding Hall
            'rec_no'    => (($prefix == 1) ? $gst_details->prefix : '') . $building->receipt_no,
            'title'     => $service_menu->service_name . ' - ' . $gst_details->name,
            'amount'    => array($building->amount),
            'gst'       => $gst_details->gst,
            'status'    => $building->status,
            'printType' => FALSE,
            
            'data'      => array(
                // Type = 1 && 3 
                'name'      => array($building->name .','. $building->tamil_name),
                'contact_no'=> $building->contact_no,
                'email'     => $building->email,
                'address'   => $building->address,
                'desc'      => $building->desc,
            ),
            
        );
        
        if(print_rec($args))
            $this->session->set_flashdata('success', 'Receipt has been printed successfully');
        
        else
            $this->session->set_flashdata('error', 'Receipt has not been printed!');
        
        /*** End ***/
        
        redirect('billing_building_fund/index/' . $menu_id, 'refresh');
    }
    
} ?>

